// Ball 객체 선언
Ball ball[];
int count = 3;
void setup() {
size(400,400);
smooth();
// Ball 객체 생성
ball = new Ball[count];
// 시작 준비 
startUp();
}
// 시작 준비 함수 
// 객체를 할당 합니다
void startUp(){
  ball[0] = new Ball(40);
  ball[0].setColor(color(100,100,200));
  for(int i = 1; i <count; i++){
    ball[i] = new Ball( random(20,30));
    ball[i].setColor( color(random(0,255),random(0,255),random(0.255)) );
  } 
}
void draw() {
  background(255);
  // 움직일 공의 위치 설정
  ball[0].setLocation(mouseX,mouseY);
  
  for( int i =1; i < count; i++){
     ball[i].move(); 
  }
  for(int i=0; i < count; i++){
   for(int j =i+1; j< count; j++){
     // 인터섹트 체크 
     if (ball[i].intersect(ball[j])) {
        ball[i].highlight();
        ball[j].highlight();
        // 만약 움직이는 공과 만났을 경우 
        if( i == 0){
          // 힘 만큼 이동 pmouse 와 mouse 이용
           ball[j].setMove( pmouseX-mouseX, pmouseY-mouseY);        
        }
        // 공 끼리 만났을 경우 
        else{
          // 각자의 힘 만큼 이동
           ball[j].setMove(ball[i].maxX/100, ball[i].maxY/100);        
           ball[i].setMove(ball[j].maxX/100, ball[j].maxY/100);
        }
      }
    }
  }
  for(int i =0; i<count; i++){
   ball[i].display(); 
  }
}


