import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class tic_tac_toe extends PApplet {

// Cell \uac1d\uccb4 \uc0dd\uc131
Cell[][] board;
// \uc138\ub85c
int cols = 3;
// \uac00\ub85c 
int rows = 3;
//\ud604\uc7ac \ub9c8\uc6b0\uc2a4 \ud074\ub9ad count
int count = 0;
//\ucd5c\ub300 \ub9c8\uc6b0\uc2a4 \ud074\ub9ad count
int maxCount = cols * rows +1;
public void setup() {
  //\ud06c\uae30\ub294 \uac00\ub85c \uc138\ub85c * 100
  size(cols*100,rows*100);
  //\uac00\ub85c \uc138\ub85c \ud06c\uae30\ub9cc\ud07c \uac1d\uccb4 \uc0dd\uc131
  board = new Cell[cols][rows]; 
  // \ucd08\uae30\ud654 \ud568\uc218 \ud638\ucd9c 
  startUp();
}
// board \ucd08\uae30\ud654 \ud568\uc218
public void startUp(){
   for(int i = 0 ; i < cols; i++){
     for(int j = 0; j < rows; j++) {
         board[i][j] = new Cell((i*100)+1,(j*100)+1,100,100);
     }
  }
}
public void draw() {
  background(0);
  fill(255);
  for (int i = 0; i < cols; i++ ) {
    for (int j = 0; j < rows; j++ ) {
        board[i][j].display();
    }
  }
  // \uc2b9\ud328 \uc720\ubb34 \ud655\uc778 \ud568\uc218 \ud638\ucd9c
  checked();
}

public void mousePressed() {
  //\ud074\ub9ad \ud588\uc744 \uacbd\uc6b0 \ud074\ub9ad\uce74\uc6b4\ud2b8 \uc0c1\uc2b9
  count++;
  for (int i = 0; i < cols; i++ ){
    for (int j = 0; j < rows; j++ ){
         //\ud074\ub9ad\ud55c \uc9c0\uc5ed\uc5d0 \uc774\ubbf8 \uadf8\ub9bc(O,X)\uc774 \uc788\uc744\uacbd\uc6b0 false \ub9ac\ud134
         if(!board[i][j].click(mouseX,mouseY,count)){
           // \ud558\uc9c0\ub9cc \ubaa8\ub4e0 \ud654\uba74\uc774 \ud074\ub9ad \ub418\uc5b4 \uc788\uc744 \uacbd\uc6b0
           if( count == maxCount){
              break; 
           }
           count--;
           println("error");
           break;
         }

    }
  }
  //\ubaa8\ub4e0 \ud654\uba74\uc774 \ud074\ub9ad\ub418\uc5c8\uc744 \uacbd\uc6b0 \ub9c8\uc9c0\ub9c9 \ud55c\ubc88\ub354 \ud074\ub9ad\ud558\uba74 \ud654\uba74 \ubc0f count \ucd08\uae30\ud654
  if(count == maxCount)
  {
    count = 0;
    //\ucd08\uae30\ud654 
    startUp();
  }
}
//\uc2b9\ud328 \ud655\uc778 \ud568\uc218 \ud638\ucd9c
public void checked()
{
  //\uc138\ub85c\uc5f4 \ud655\uc778 \ud568\uc218 \ub9ac\ud134: -1\uc77c \uacbd\uc6b0 \uc2e4\ud328
  if(colsCheck() != -1){
    fill(0);
    rect( colsCheck()* 100 + 45 , 0, 8,height);
    //\uac8c\uc784 \uc885\ub8cc \uc900\ube44
    count = maxCount-1;
  }
  //\uac00\ub85c\uc5f4 \ud655\uc778 \ud568\uc218 \ub9ac\ud134: -1\uc77c \uacbd\uc6b0 \uc2e4\ud328
  if(rowsCheck() != -1){
    fill(0);
    rect( 0 , rowsCheck()* 100 + 45 , width,8);
    //\uac8c\uc784 \uc885\ub8cc \uc900\ube44
    count = maxCount-1;
  }
  //\ub300\uac01\uc120 \ud655\uc778 \ud568\uc218 \ub9ac\ud134: -1\uc77c \uacbd\uc6b0 \uc2e4\ud328
  if( diagonalCheck() != -1){
     if( diagonalCheck() == 1){
        line(0,0, width, height) ;
     }
     if( diagonalCheck() == 2){
        line(width,0,0,height ) ;
     }
     //\uac8c\uc784 \uc885\ub8cc \uc900\ube44
      count = maxCount-1;
  }
}
//\uc138\ub85c\uc5f4 \ud655\uc778 \ud568\uc218 \ub9ac\ud134: -1 \ub610\ub294 \uc644\ub8cc\ub41c cols count
public int colsCheck(){
  int nowState = 0;
  // \ub9ac\ud134 \uac12 \ucd08\uae30\ud654 -1
  int returnIndex = -1;
    for(int i = 0; i < cols; i++){
        nowState = board[i][0].getState();
        // \ud604\uc7ac \uc0c1\ud0dc \ud074\ub9ad \uc548\ub41c\uacbd\uc6b0 (0) 
        if( nowState == 0){
           continue; 
        }
        for(int j =0; j < rows; j++){
          if( nowState == board[i][j].getState() ){
              returnIndex = i;
              // \ub05d\uae4c\uc9c0 \ud655\uc778\ud55c \uacbd\uc6b0 \ud574\ub2f9 \ub9ac\ud134  
              if( j+1 == rows ){
                 return returnIndex; 
              }
          }
          else{
              returnIndex = -1;
              break;
          }
        }
    }
    return returnIndex;
}
// \uac00\ub85c\uc5f4 \ud655\uc778 \ud568\uc218 \ub9ac\ud134: -1 \ub610\ub294 \uc644\ub8cc\ub41c rows count
public int rowsCheck(){
  int nowState = 0;
  // \ub9ac\ud134 \uac12 \ucd08\uae30\ud654 -1  
  int returnIndex = -1;
    for(int i = 0; i < cols; i++){
        nowState = board[0][i].getState();
        // \ud604\uc7ac \uc0c1\ud0dc \ud074\ub9ad \uc548\ub41c\uacbd\uc6b0 (0)         
        if( nowState == 0){
           continue; 
        }
        for(int j =0; j < rows; j++){
          if( nowState == board[j][i].getState() ){
              returnIndex = i;
              //\ub05d\uae4c\uc9c0 \ud655\uc778\ud55c \uacbd\uc6b0 \ub9ac\ud134
              if( j+1 == rows ){
                 return returnIndex; 
              }
          }
          else{
              returnIndex = -1;
              break;
          }
        }
    }
    return returnIndex;
}
// \ub300\uac01\uc120\uc744 \ud655\uc778\ud558\ub294 \ud568\uc218 \ub9ac\ud134: -1\ub610\ub294 \uc21c\ud589 1, \uc5ed\ud589 2
public int diagonalCheck(){
  int nowState = 0;
  int returnIndex = -1;
  //\uc21c\ud589 \uac80\uc0ac
  nowState = board[0][0].getState();
  for(int i = 0; i < cols; i++){
      if( nowState == 0){
          break;
      }
      if( nowState == board[i][i].getState()){
         returnIndex = 1; 
         if( i + 1 == cols){
            return returnIndex; 
         }
      }
      else{
         returnIndex = -1; 
         break;
      }
  }
  //\uc5ed\ud589 \uac80\uc0ac
  // 02, 11, 02
  nowState = board[cols-1][0].getState();
  int tempIndex = 0;
  for(int i = cols-1 ; i > 0; i--){
      if( nowState == 0){
          break;
      }
      if( nowState == board[tempIndex][i].getState()){
         returnIndex = 2; 
         tempIndex++;
         if( i == cols){
            return returnIndex; 
         }
      }
      else{
         returnIndex = -1; 
         break;
      }
  }
  return returnIndex;
}
// A Cell object
class Cell {
// x,y \uc88c\ud45c
float x,y;
// \uac00\ub85c, \uc138\ub85c \ud06c\uae30
float w,h;
//\ud604\uc7ac \uc0c1\ud0dc 0\uc77c\uacbd\uc6b0 \ube44\uc5b4\uc788\uc74c, 1\uc77c\uacbd\uc6b0 O, 2\uc77c\uacbd\uc6b0 X
int state;
// Cell Constructor
Cell(float tempX, float tempY, float tempW, float tempH) {
  x = tempX;
  y = tempY;
  w = tempW;
  h = tempH;
  state = 0;
}
public boolean click(float nowX, float nowY,int nowState) {
  //\ub9c8\uc6b0\uc2a4 \ud074\ub9ad\ud55c \uc601\uc5ed\uc774 \ud604\uc7ac \uac1d\uccb4 \uc77c\uacbd\uc6b0 
  if( x < nowX && x+w > nowX && y < nowY && y+h > nowY)
  {
    //\ud074\ub9ad\ud55c \uac1d\uccb4\uc758 \uc0c1\ud0dc\uac00 \ube44\uc5b4\uc788\uc744\uacbd\uc6b0
    if( state == 0){
        //\ud074\ub9ad\ud55c \uac1d\uccb4\uc758 \uc0c1\ud0dc\ub97c \ud640\uc218\uc9dd\uc218\ub85c \uad6c\ubcc4
        state = (nowState % 2) +1;
        return true;      
    }
    else{
       return false; 
    }
  }
  else{
     return true; 
  }
}
public void display(){
  fill(255);
  rect(x,y,w,h);
  //\uc0c1\ud0dc\uac00 1\uc77c \uacbd\uc6b0 O \uadf8\ub9ac\uae30
  if( state == 1)
  {
    fill(0);
    ellipse(x+50,y+50, w-50,h-50);
    fill(255);
    ellipse(x+50,y+50, w-60,h-60);
  }
  // \uc0c1\ud0dc\uac00 2\uc77c\uacbd\uc6b0 X \uadf8\ub9ac\uae30
  else if( state == 2)
  {
    // line() \uc774\uc6a9
    //line(x+20,y+20,x+80,y+80);
    //line(x+20,y+80, x+80,y+20);
    
    // vertex \uc774\uc6a9
     fill(0);
     beginShape();
     vertex(x+20,y+20);
     vertex(x+25,y+20);
     vertex(x+50,y+45);
     vertex(x+75,y+20);
     vertex(x+80,y+20);
     vertex(x+55,y+50);
     vertex(x+80,y+80);
     vertex(x+75,y+80);
     vertex(x+50,y+55);
     vertex(x+25,y+80);
     vertex(x+20,y+80);
     vertex(x+45,y+50);
     endShape();
  }
}

public int getState(){
  return state;
}

}



  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F4F4F4", "tic_tac_toe" });
  }
}
